Wt: Wt::WTemplate Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Protected Member Functions
Wt::WTemplate Class Reference

A widget that renders an XHTML template. More...

`#include <Wt/WTemplate>`

Inheritance diagram for Wt::WTemplate:
[legend]

List of all members.

## Classes
struct | Functions
| A collection of predefined functions. More...
## Public Types
typedef boost::function< bool(WTemplate *t, const std::vector< WString > &args, std::ostream &result) | Function )
| A function type.
## Public Member Functions
| WTemplate (WContainerWidget *parent=0)
| Creates a template widget.
| WTemplate (const WString &text, WContainerWidget *parent=0)
| Creates a template widget with given template.
const WString & | templateText () const
| Returns the template.
void | setTemplateText (const WString &text, TextFormat textFormat=XHTMLText)
| Sets the template text.
virtual void | bindString (const std::string &varName, const WString &value, TextFormat textFormat=XHTMLText)
| Binds a string value to a variable.
void | bindInt (const std::string &varName, int value)
| Binds an integer value to a variable.
virtual void | bindWidget (const std::string &varName, WWidget *widget)
| Binds a widget to a variable.
WWidget * | takeWidget (const std::string &varName)
| Unbinds a widget.
void | bindEmpty (const std::string &varName)
| Binds an empty string to a variable.
void | addFunction (const std::string &name, const Function &function)
| Binds a function.
void | setCondition (const std::string &name, bool value)
| Sets a condition.
bool | conditionValue (const std::string &name) const
| Returns a condition value.
virtual void | resolveString (const std::string &varName, const std::vector< WString > &args, std::ostream &result)
| Resolves the string value for a variable name.
virtual void | handleUnresolvedVariable (const std::string &varName, const std::vector< WString > &args, std::ostream &result)
| Handles a variable that could not be resolved.
virtual WWidget * | resolveWidget (const std::string &varName)
| Resolves a widget for a variable name.
virtual bool | resolveFunction (const std::string &name, const std::vector< WString > &args, std::ostream &result)
| Resolves a function call.
template<typename T >
T | resolve (const std::string &varName)
| Returns a widget for a variable name.
virtual void | clear ()
| Erases all variable bindings.
void | setInternalPathEncoding (bool enabled)
| Enables internal path anchors in the XHTML template.
bool | hasInternalPathEncoding () const
| Returns whether internal paths are enabled.
virtual void | refresh ()
| Refresh the widget.
virtual void | renderTemplate (std::ostream &result)
| Renders the template into the given result stream.
void | renderTemplateText (std::ostream &result, const WString &templateText)
| Renders a template into the given result stream.
## Protected Member Functions
virtual void | applyArguments (WWidget *w, const std::vector< WString > &args)
| Applies arguments to a resolved widget.
void | format (std::ostream &result, const std::string &s, TextFormat textFormat=PlainText)
| Utility method to safely format an XHTML string.
void | format (std::ostream &result, const WString &s, TextFormat textFormat=PlainText)
| Utility method to safely format an XHTML string.
virtual void | enableAjax ()
| Progresses to an Ajax-enabled widget.

## Detailed Description

A widget that renders an XHTML template.

The XHTML template may contain references to variables which replaced by strings are widgets.

Since the template text may be supplied by a WString, you can conveniently store the string in a message resource bundle, and make it localized by using WString::tr().

Placeholders (for variables and functions) are delimited by: `${...}`. To use a literal `"${"`, use `"$${"`.

Usage example:

     WString userName = ...;

     WTemplate *t = new WTemplate();
     t->setTemplateText("<div> How old are you, ${friend} ? ${age-input} </div>");

     t->bindString("friend", userName, PlainText);
     t->bindWidget("age-input", ageEdit_ = new WLineEdit());

There are currently three syntactic constructs defined: variable place holders, functions and conditional blocks.

### A. Variable placeholders

`${var}` defines a placeholder for the variable "var", and gets replaced with whatever is bound to that variable:

- a widget, using bindWidget()
- a string value, using bindString() or bindInt()
- or in general, the result of resolveString() and resolveWidget() methods.

Optionally, additional arguments can be specified using the following syntax:

`${var arg1="A value" arg2='A second value'}`

The arguments can thus be simple simple strings or quoted strings (single or double quoted). These arguments are applied to a resolved widget in applyArguments() and currently supports only style classes.

You can bind widgets and values to variables using bindWidget(), bindString() or bindInt() or by reimplementing the resolveString() and resolveWidget() methods.

Note:
  The use of XML comments (`<!-- ... -->`) around variables that are bound to widgets will result in bad behaviour since the template parser is ignorant about these comments and the corresponding widgets will believe that they are rendered but aren't actually.

### B. Functions

`${fun:arg}` defines a placeholder for applying a function "fun" to an argument "arg".

Optionally, additional arguments can be specified as with a variable placeholder.

Functions are resolved by resolveFunction(), and the default implementation considers functions bound with addFunction(). There are currently three functions that are generally useful:

- Functions::tr : resolves a localized strings, this is convenient to create a language neutral template, which contains translated strings
- Functions::id : resolves the id of a bound widget, this is convenient to bind <label> elements to a form widget using its for attribute.
- Functions::block : recursively renders another string as macro block optional arguments substituted before processing template substitution.

For example, the following template uses the "tr" function to translate the age-label using the "age-label" internationalized key.

     WTemplate *t = new WTemplate();
     t->addFunction("tr", &WTemplate::Functions::tr);
     t->setTemplateText("<div> ${tr:age-label} ${age-input} </div>");
     t->bindWidget("age-input", ageEdit_ = new WLineEdit());

### C. Conditional blocks

`${<cond>}` starts a conditional block with a condition name "cond", and must be closed by a balanced `${</cond>}`.

For example:

     WTemplate *t = new WTemplate();
     t->setTemplateText("<div> ${<if-register>} Register ... ${</if-register>}</div>");
     t->setCondition("if-register", true);

Conditions are set using setCondition().

The template can return a bound widget using resolve(), which already tries to cast the widget to the proper type.

### CSS

This widget does not provide styling, and can be styled using inline or external CSS as appropriate.

## Member Typedef Documentation

typedef boost::function<bool(WTemplate *t, const std::vector<WString>& args, std::ostream& result) Wt::WTemplate::Function)

A function type.

See also:
  addFunction()
  Functions::tr, Functions::id, Functions::block

## Constructor & Destructor Documentation

Wt::WTemplate::WTemplate | ( | const WString & | text,
|  | WContainerWidget * | parent = `0`
| ) |  |

Creates a template widget with given template.

The `templateText` must be proper XHTML, and this is checked unless the XHTML is resolved from a message resource bundle. This behavior is similar to a WText when configured with the Wt::XHTMLText textformat.

## Member Function Documentation

void Wt::WTemplate::addFunction | ( | const std::string & | name,
|  | const Function & | function
| ) |  |

Binds a function.

Functions are useful to automatically resolve placeholders.

The syntax for a function 'fun' applied to a single argument 'bla' is:

`${fun:bla}`

There are three predefined functions, which can be bound using:

     WTemplate *t = ...;
     t->addFunction("id", &WTemplate::Functions::id);
     t->addFunction("tr", &WTemplate::Functions::tr);
     t->addFunction("block", &WTemplate::Functions::block);

void Wt::WTemplate::applyArguments | ( | WWidget * | w,
|  | const std::vector< WString > & | args
| ) |  | `[protected, virtual]`

Applies arguments to a resolved widget.

Currently only a `class` argument is handled, which adds one or more style classes to the widget `w`, using WWidget::addStyleClass().

void Wt::WTemplate::bindEmpty | ( | const std::string & | varName | ) |

Binds an empty string to a variable.

If a widget was bound to the variable, it is deleted first.

See also:
  bindString()

void Wt::WTemplate::bindInt | ( | const std::string & | varName,
|  | int | value
| ) |  |

Binds an integer value to a variable.

See also:
  bindString()

void Wt::WTemplate::bindString | ( | const std::string & | varName,
|  | const WString & | value,
|  | TextFormat | textFormat = `XHTMLText`
| ) |  | `[virtual]`

Binds a string value to a variable.

Each occurrence of the variable within the template will be substituted by its value.

Depending on the `textFormat`, the `value` is validated according as for a WText.

See also:
  bindWidget(), bindInt()
  resolveString()

void Wt::WTemplate::bindWidget | ( | const std::string & | varName,
|  | WWidget * | widget
| ) |  | `[virtual]`

Binds a widget to a variable.

The corresponding variable reference within the template will be replaced with the widget (rendered as XHTML). Since a single widget may be instantiated only once in a template, the variable `varName` may occur at most once in the template, and the `widget` must not yet be bound to another variable.

If a widget was already bound to the variable, it is deleted first. If previously a string or other value was bound to the variable, it is removed.

You may also pass a `0` `widget`, which will resolve to an empty string.

See also:
  bindString()
  resolveWidget()

void Wt::WTemplate::clear | ( |  | ) | `[virtual]`

Erases all variable bindings.

Removes all strings and deletes all widgets that were previously bound using bindString() and bindWidget().

This also resets all conditions set using setCondition(), but does not remove functions added with addFunction()

bool Wt::WTemplate::conditionValue | ( | const std::string & | name | ) | const

Returns a condition value.

See also:
  setCondition()

void Wt::WTemplate::enableAjax | ( |  | ) | `[protected, virtual]`

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also:
  WApplication::enableAjax()

Reimplemented from Wt::WWebWidget.

void Wt::WTemplate::format | ( | std::ostream & | result,
|  | const std::string & | s,
|  | TextFormat | textFormat = `PlainText`
| ) |  | `[protected]`

Utility method to safely format an XHTML string.

The string is formatted according to the indicated `textFormat`. It is recommended to use this method when specializing resolveString() to avoid security risks.

void Wt::WTemplate::format | ( | std::ostream & | result,
|  | const WString & | s,
|  | TextFormat | textFormat = `PlainText`
| ) |  | `[protected]`

Utility method to safely format an XHTML string.

The string is formatted according to the indicated `textFormat`. It is recommended to use this method when specializing resolveString() to avoid security risks.

void Wt::WTemplate::handleUnresolvedVariable | ( | const std::string & | varName,
|  | const std::vector< WString > & | args,
|  | std::ostream & | result
| ) |  | `[virtual]`

Handles a variable that could not be resolved.

This method is called from resolveString() for variables that could not be resolved.

The default implementation implementation writes "??" + varName + "??" to the result stream.

The result stream expects a UTF-8 encoded string value.

Warning:
  When specializing this class, you need to make sure that you append proper XHTML to the `result`, without unsafe active contents. The format() methods may be used for this purpose.

See also:
  resolveString()

bool Wt::WTemplate::hasInternalPathEncoding | ( |  | ) | const

Returns whether internal paths are enabled.

See also:
  setInternalPathEncoding()

void Wt::WTemplate::refresh | ( |  | ) | `[virtual]`

Refresh the widget.

The refresh method is invoked when the locale is changed using WApplication::setLocale() or when the user hit the refresh button.

The widget must actualize its contents in response.

Reimplemented from Wt::WWebWidget.

void Wt::WTemplate::renderTemplate | ( | std::ostream & | result | ) | `[virtual]`

Renders the template into the given result stream.

The default implementation will call renderTemplateText() with the templateText().

void Wt::WTemplate::renderTemplateText | ( | std::ostream & | result,
|  | const WString & | templateText
| ) |  |

Renders a template into the given result stream.

The default implementation will parse the template, and resolve variables by calling resolveString().

You may want to reimplement this method to manage resources that are needed to load content on-demand (e.g. database objects), or support a custom template language.

template<typename T >

T Wt::WTemplate::resolve | ( | const std::string & | varName | ) |

Returns a widget for a variable name.

This is a convience method, which calls resolveWidget() and casts the result to type `T`. You may use this method to fetch widgets that have previously been bound using bindWidget().

bool Wt::WTemplate::resolveFunction | ( | const std::string & | name,
|  | const std::vector< WString > & | args,
|  | std::ostream & | result
| ) |  | `[virtual]`

Resolves a function call.

This resolves a function with name `name`, and one or more arguments `args`, and writes the result into the stream `result`. The method returns whether a function was matched and applied.

The default implementation considers functions that were bound using addFunction().

See also:
  addFunction()

void Wt::WTemplate::resolveString | ( | const std::string & | varName,
|  | const std::vector< WString > & | args,
|  | std::ostream & | result
| ) |  | `[virtual]`

Resolves the string value for a variable name.

This is the main method used to resolve variables in the template text, during rendering.

The default implementation considers first whether a string was bound using bindString(). If so, that string is returned. If not, it will attempt to resolve a widget with that variable name using resolveWidget(), and render it as XHTML. If that fails too, handleUnresolvedVariable() is called, passing the initial arguments.

You may want to reimplement this method to provide on-demand loading of strings for your template.

The result stream expects a UTF-8 encoded string value.

Warning:
  When specializing this class, you need to make sure that you append proper XHTML to the `result`, without unsafe active contents. The format() methods may be used for this purpose.

See also:
  renderTemplate()

WWidget * Wt::WTemplate::resolveWidget | ( | const std::string & | varName | ) | `[virtual]`

Resolves a widget for a variable name.

The default implementation returns a widget that was bound using bindWidget().

You may want to reimplement this method to create widgets on-demand. All widgets that are returned by this method are reparented to the WTemplate, so they will be deleted when the template is destroyed, but they are not deleted by clear() (unless bind was called on them as in the example below).

This method is typically used for delayed binding of widgets. Usage example:

     if (Wt::Widget *known = WTemplate::resolveWidget(varName)) {
       return known;
     } else {
       if (varName == "age-input") {
         Wt::WWidget *w = new Wt::WLineEdit(); // widget only created when used
         bind(varName, w);
         return w;
       }
     }

void Wt::WTemplate::setCondition | ( | const std::string & | name,
|  | bool | value
| ) |  |

Sets a condition.

This enables or disables the inclusion of a conditional block.

The default value of all conditions is `false`.

void Wt::WTemplate::setInternalPathEncoding | ( | bool | enabled | ) |

Enables internal path anchors in the XHTML template.

Anchors to internal paths are represented differently depending on the session implementation (plain HTML, Ajax or HTML5 history). By enabling this option, anchors which reference an internal path (by referring a URL of the form `href="#/..."`), are re-encoded to link to the internal path.

The default value is `false`.

See also:
  WAnchor::setRefInternalPath()

void Wt::WTemplate::setTemplateText | ( | const WString & | text,
|  | TextFormat | textFormat = `XHTMLText`
| ) |  |

Sets the template text.

The `text` must be proper XHTML, and this is checked unless the XHTML is resolved from a message resource bundle or TextFormat is Wt::XHTMLUnsafeText. This behavior is similar to a WText when configured with the Wt::XHTMLText textformat.

Changing the template text does not clear() bound widgets or values.

See also:
  clear()

WWidget * Wt::WTemplate::takeWidget | ( | const std::string & | varName | ) |

Unbinds a widget.

This removes a previously bound widget and unbinds the corresponding variable, effectively undoing the effect of bindWidget().

The widget is not deleted, but returned instead. cpp

const WString& Wt::WTemplate::templateText | ( |  | ) | const

Returns the template.

See also:
  setTemplateText()

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator